if (isJsEnabled()) {
  addLoadEvent(karmaAutoAttach);
}

function karmaAutoAttach() {
  var selects = document.getElementsByTagName('select');
  for (i = 0; select = selects[i]; i++) {
    if (select && hasClass(select, 'karma-rating-select')) {
      // Submit via AJAX.
      select.form.onsubmit = function () {
        type_id = this.id.replace('karma_rate_', '').replace('_', '-');
        select = $('edit-rating-'+ type_id);
        uri = $('uri-rating-'+ type_id).value;
        ratingText = $('karma-rating-text-'+ type_id);
        throbber = document.createElement('span');
        throbber.className = 'throbber';
        throbber.innerHTML = '&nbsp;';
        select.parentNode.insertBefore(throbber, select.nextSibling);
        HTTPPost(uri, karmaHandleResponse, {
          throbber: throbber,
          ratingText: ratingText,
          currentRating: $('current-rating-'+ type_id)
        }, {
          'edit[rating]': select.options[select.selectedIndex].value,
          'edit[form_id]': this.id,
          'op': 'Rate',
          'edit[form_token]' : this.elements['edit[form_token]'].value
        });
        return false;
      }

      // Submit on selection change.
      select.onchange = function () {
        this.form.onsubmit();
      }
    }
  }
}

function karmaHandleResponse(responseText, xmlHttp, parameter) {
  removeNode(parameter.throbber);
  response = parseJson(responseText);
  if (parameter.ratingText) {
    parameter.ratingText.innerHTML = response.data;
  }
  if (parameter.currentRating) {
    parameter.currentRating.style.width = ''+ (parseFloat(response.current_rating) * 17) +'px';
  }
}

function karmaSelectRating(type, id, rating) {
  select = $('edit-rating-'+ type +'-'+ id);
  for (option = 0; option < select.options.length; option++) {
    if (select.options[option].value == rating) {
      select.selectedIndex = option;
      select.form.onsubmit();
      rating = parseInt(select.options[select.selectedIndex].value);
      if (rating < 0) {
        rating = 0;
      }
      if ($('karma-stars-zero-'+ id)) {
        if (rating == 0) {
          addClass($('karma-stars-zero-'+ type +'-'+ id), 'karma-stars-zero-selected');
        }
        else {
          removeClass($('karma-stars-zero-'+ type +'-'+ id), 'karma-stars-zero-selected');
        }
      }
      if (rating == -1) {
        addClass($('karma-not-rated-'+ type +'-'+ id), 'karma-not-rated-selected');
      }
      else {
        removeClass($('karma-not-rated-'+ type +'-'+ id), 'karma-not-rated-selected');
      }
      break;
    }
  }
}
